<template>
  <div class="app-container calendar-list-container">

    <!-- 查询和其他操作 -->
    <div class="filter-container">
      <el-select v-model="listQuery.type" clearable placeholder="积分规则类型" style="top: -4px;width: 200px;">
        <el-option :key="item.dictValue" v-for="item in allTypeList" :label="item.dictLabel" :value="item.dictValue">
        </el-option>
      </el-select>
      <el-button class="filter-item" type="primary" v-waves icon="el-icon-search" @click="handleFilter">查找</el-button>
      <el-button class="filter-item" type="primary" @click="handleCreate" icon="el-icon-edit">添加</el-button>
    </div>

    <!-- 查询结果 -->
    <el-table size="small" :data="list" v-loading="listLoading" element-loading-text="正在查询中。。。" border fit
      highlight-current-row>
      <el-table-column type="index" label="序号" header-align="center" align="center">
      </el-table-column>

      <el-table-column align="center" min-width="100px" label="积分类型" prop="integralTypeName">
      </el-table-column>

      <!-- <el-table-column align="center" min-width="200px" label="积分说明" prop="integralName">
      </el-table-column> -->
      <el-table-column align="center" min-width="80px" label="积分" prop="integral">
      </el-table-column>
      <el-table-column align="center" min-width="80px" label="状态">
        <template slot-scope="props">
          <el-tag type="success" v-if="props.row.status == 1">启用</el-tag>
          <el-tag type="danger" v-if="props.row.status == 0">关闭</el-tag>
        </template>
      </el-table-column>
      <el-table-column align="center" label="操作" width="240px" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button type="primary" size="small" @click="handleUpdate(scope.row, false)">编辑</el-button>
          <el-button v-if="scope.row.status == 0" type="success" size="small"
            @click="changeState(scope.row.id, 1)">开启</el-button>
          <el-button v-if="scope.row.status == 1" type="warning" size="small"
            @click="changeState(scope.row.id, 0)">关闭</el-button>
          <el-button type="danger" size="mini" @click="handleDelete(scope.row.id, -1)">删除</el-button>
        </template>
      </el-table-column>
    </el-table>

    <!-- 分页 -->
    <div class="pagination-container">
      <el-pagination background @size-change="handleSizeChange" @current-change="handleCurrentChange"
        :current-page="listQuery.page" :page-sizes="[10, 20, 30, 50]" :page-size="listQuery.limit"
        layout="total, sizes, prev, pager, next, jumper" :total="total">
      </el-pagination>
    </div>

    <!-- 添加或修改对话框 -->
    <el-dialog :close-on-click-modal="false" :title="textMap[dialogStatus]" :visible.sync="dialogFormVisible" width="45%">
      <el-form :rules="rules" ref="dataForm" :model="dataForm" status-icon label-position="left" label-width="100px"
        style='width:700px; margin-left:50px;'>

        <el-form-item v-if="dialogStatus == 'create'" label="规则类型" prop="integralType">
          <el-select v-model="dataForm.integralType" clearable  style="width: 350px;">
            <el-option :key="item.dictValue" v-for="item in allTypeList" :label="item.dictLabel" :value="item.dictValue">
            </el-option>
          </el-select>
        </el-form-item>
        <el-form-item v-else label="规则类型">
          <el-input disabled v-model="dataForm.integralTypeName" style="width: 350px"></el-input>
              </el-form-item>
        <el-form-item label="积分" prop="integral">
                <el-input-number
                  :precision="0"
                  :step="1"
                  v-model="dataForm.integral"
                ></el-input-number>
              </el-form-item>
        
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button @click="dialogFormVisible = false">取消</el-button>
        <el-button v-if="dialogStatus == 'create'" type="primary" @click="createData">确定</el-button>
        <el-button v-else type="primary" @click="updateData">确定</el-button>
      </div>
    </el-dialog>

  </div>
</template>
  
<style>
.demo-table-expand {
  font-size: 0;
}

.demo-table-expand label {
  width: 200px;
  color: #99a9bf;
}

.demo-table-expand .el-form-item {
  margin-right: 0;
  margin-bottom: 0;
}
</style>
  
<script>
import { getPointRulesList, pointRulesCreateItem, pointRulesUpdateItem, pointRulesState } from "@/api/pointManage";
import { dataTypeList } from "@/api/public";
import waves from "@/directive/waves"; // 水波纹指令
import Tinymce from '@/components/Tinymce'

export default {
  name: 'pointRulesList',
  components: { Tinymce },
  directives: { waves },
  data() {
    return {
      allTypeList: [
        
      ],
      flagList: [
        {
          type: 1,
          name: '启用'
        },
        {
          type: 0,
          name: '禁用'
        },
      ],
      list: [],
      total: 0,
      listLoading: false,
      listQuery: {
        page: 1,
        limit: 10,
        type: '',
      },
      dataForm: {
        integral: undefined,
        integralType: undefined,
      },
      dialogFormVisible: false,
      dialogStatus: '',
      textMap: {
        update: "编辑",
        create: "创建",
      },
      rules: {
        integral: [{ required: true, message: "积分不能为空", trigger: "blur" }],
        integralType: [{ required: true, message: "请选择规则类型", trigger: "blur" }],
      },
    }
  },
  created() {
    this.getPointRulesType();
    this.getList();
  },
  methods: {
    changeState(ruleId, index) {
      pointRulesState({ ruleId: ruleId, status: index }).then(response => {
                this.$notify({
                    title: '成功',
                    message: '活动状态修改成功',
                    type: 'success',
                    duration: 2000
                })
                this.getList()
            })
        },
        handleDelete(ruleId, index) {
            this.$confirm('确认删除吗?', '提示', {
                confirmButtonText: '确定',
                cancelButtonText: '取消',
                type: 'warning'
            }).then(() => {
              pointRulesState({ ruleId: ruleId, status: index }).then(response => {
                    this.$notify({
                        title: '成功',
                        message: '删除成功',
                        type: 'success',
                        duration: 2000
                    })
                    this.getList();
                })
            }).catch(() => {})

        },
    resetForm() {
      this.dataForm = {
        integral: '',
        integralType: '',
      };
    },
    handleCreate() {

      this.resetForm();
      this.dialogFormVisible = true;
      this.dialogStatus = "create";
      this.$nextTick(() => {
        this.$refs["dataForm"].clearValidate();
      });
    },
    createData() {
      this.$refs["dataForm"].validate((valid) => {
        if (valid) {
          console.log(this.dataForm);
          pointRulesCreateItem(this.dataForm)
            .then((response) => {
              this.dialogFormVisible = false;
              this.$notify({
                title: "成功",
                message: "创建成功",
                type: "success",
                duration: 2000,
              });
              this.getList();
            })
            .catch(() => { });
        }
      });
    },
    getPointRulesType() {
      dataTypeList({dictType:'integral_rule_type'}).then(response => {
        this.allTypeList = response.data.data;
      }).catch(() => {

      });
    },

    getList() {
      this.listLoading = true
      getPointRulesList(this.listQuery).then(response => {
        this.list = response.data.data.items
        this.total = response.data.data.total
        this.listLoading = false
      }).catch(() => {

      })
    },

    handleFilter() {
      this.listQuery.page = 1
      this.getList()
    },

    handleSizeChange(val) {
      this.listQuery.limit = val
      this.getList()
    },

    handleCurrentChange(val) {
      this.listQuery.page = val
      this.getList()
    },

    handleUpdate(row) {
      this.dataForm = Object.assign({}, row);
      this.dialogStatus = 'update'
      this.dialogFormVisible = true
      this.$nextTick(() => {
        this.$refs['dataForm'].clearValidate()
      })
    },

    updateData() {
      this.$refs['dataForm'].validate((valid) => {
        if (valid) {
          pointRulesUpdateItem(this.dataForm).then(() => {
            this.dialogFormVisible = false
            this.$notify({
              title: '成功',
              message: '更新成功',
              type: 'success',
              duration: 2000
            })
            this.getList()
          })
        }
      })
    },
  }
}
</script>
<style>
.ad-avatar-uploader .el-upload {
  border: 1px dashed #d9d9d9;
  border-radius: 6px;
  cursor: pointer;
  position: relative;
  overflow: hidden;
}

.ad-avatar-uploader .el-upload:hover {
  border-color: #409EFF;
}

.ad-avatar-uploader-icon {
  font-size: 28px;
  color: #8c939d;
  width: 178px;
  height: 178px;
  line-height: 178px;
  text-align: center;
}

.ad-avatar {
  display: block;
}
</style>
  